import * as React from "react";
import * as echarts from "echarts";
import "./Test.less";
import * as ReactDOM from "react-dom";
import * as grid from "../../index";

interface TestProps {

}

interface TestStates {

}

export class Test extends React.PureComponent<TestProps, TestStates> {
    constructor(props: TestProps) {
        super(props);
        this.state = {};
    }

    render() {
        return <div ref="chart" className={"echartContainer"}/>;
    }

    componentDidMount() {
        const instance = echarts.init(ReactDOM.findDOMNode(this.refs.chart) as any);
        const options = grid.init({
            instance,
            fields: ["t1", "t2", "t3", "t4", "t5", "t6"],
            columns: {
                fields: [["t6"]],
                type: "metric",
                splitNumber: 5
            },
            rows: {
                fields: [["t2"]],
                type: "dimension",
                splitNumber: 5
            },
            dataset: [
                [12, "def", "category1", "中国", "北京", 30],
                [18, "def2", "category1", "中国", "北京", 90],
                [24, "def", "category2", "中国", "北京", 50],
                [32, "abc", "category2", "中国", "广州", 100]
            ],
            cellWidth: 120,
            cellHeight: 40,
            headerWidth: 80,
            headerHeight: 30,
            canvasWidth: instance.getWidth(),
            canvasHeight: instance.getHeight(),
            seriesOptions: {
                type: "bar",
                itemStyle: {
                    color: "orange"
                }
            },
            xAxisOptions: {
                type: "category",
                axisLabel: {
                    color: "#000",
                },
                axisTick: {
                    lineStyle: {
                        color: "#ccc"
                    }
                },
                axisLine: {
                    lineStyle: {
                        color: "#ccc"
                    }
                }
            },
            yAxisOptions: {
                min: 0,
                max: 120,
                type: "value",
                axisTick: {
                    lineStyle: {
                        color: "#ccc"
                    },
                },
                axisLine: {
                    lineStyle: {
                        color: "#ccc"
                    }
                },
                axisLabel: {
                    color: "#000",
                }
            }
        });
        instance.setOption({
            tooltip: {
                trigger: "axis"
            },
            ...options
        } as any);
        setTimeout(() => {
            instance.resize();
        }, 1000);
    }
}
